Rectangle

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Rectangle

    java.lang.Object
      java.awt.Rectangle

All Implemented Interfaces:
  Shape, Serializable, Cloneable

    public class Rectangle

extends Object
implements Shape, Serializable, Cloneable

A `Rectangle` specifies an area in a coordinate space that is enclosed by the `Rectangle` object's top-left point (x, y) in the coordinate space, its width, and its height.

A `Rectangle` object's `width` and `height` are `public` fields. The constructors that create a `Rectangle`, and the methods that can modify one, do not prevent setting a negative value for width or height.

A `Rectangle` whose width or height is negative is considered empty. If the `Rectangle` is empty, then the `isEmpty` method returns `true`. No point can be contained by or inside an empty `Rectangle`. The values of `width` and `height`, however, are still valid. An empty `Rectangle` still has a location in the coordinate space, and methods that change its size or location remain valid. The behavior of methods that operate on more than one `Rectangle` is undefined if any of the participating `Rectangle` objects has a negative `width` or `height`. These methods include `intersects`, `intersection`, and `union`.

Since:
  JDK1.0
Version:
  1.65, 01/23/03
Author:
  Sami Shaio
See Also:
  Serialized Form

Field Summary
`int` | `height` The height of the `Rectangle`.
`int` | `width` The width of the `Rectangle`.
`int` | `x` The x coordinate of the `Rectangle`.
`int` | `y` The y coordinate of the `Rectangle`.

Constructor Summary
`Rectangle()` Constructs a new `Rectangle` whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are both zero.
`Rectangle(Dimension d)` Constructs a new `Rectangle` whose top left corner is (0, 0) and whose width and height are specified by the `Dimension` argument.
`Rectangle(int width, int height)` Constructs a new `Rectangle` whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are specified by the arguments of the same name.
`Rectangle(int x, int y, int width, int height)` Constructs a new `Rectangle` whose top-left corner is specified as (`x`, `y`) and whose width and height are specified by the arguments of the same name.
`Rectangle(Point p)` Constructs a new `Rectangle` whose top-left corner is the specified `Point`, and whose width and height are both zero.
`Rectangle(Point p, Dimension d)` Constructs a new `Rectangle` whose top-left corner is specified by the `Point` argument, and whose width and height are specified by the `Dimension` argument.
`Rectangle(Rectangle r)` Constructs a new `Rectangle`, initialized to match the values of the specified `Rectangle`.

Method Summary
`void` | `add(int newx, int newy)` Adds a point, specified by the integer arguments `newx` and `newy`, to this `Rectangle`.
`void` | `add(Point pt)` Adds the specified `Point` to this `Rectangle`.
`void` | `add(Rectangle r)` Adds a `Rectangle` to this `Rectangle`.
`Object` | `clone()` Creates a new object of the same class and with the same contents as this object.
`boolean` | `contains(int x, int y)` Checks whether or not this `Rectangle` contains the point at the specified location (x, y).
`boolean` | `contains(int X, int Y, int W, int H)` Checks whether this `Rectangle` entirely contains the `Rectangle` at the specified location (X, Y) with the specified dimensions (W, H).
`boolean` | `contains(Point p)` Checks whether or not this `Rectangle` contains the specified `Point`.
`boolean` | `contains(Rectangle r)` Checks whether or not this `Rectangle` entirely contains the specified `Rectangle`.
`boolean` | `equals(Object obj)` Checks whether two rectangles are equal.
`Rectangle` | `getBounds()` Gets the bounding `Rectangle` of this `Rectangle`.
`Point` | `getLocation()` Returns the location of this `Rectangle`.
`Dimension` | `getSize()` Gets the size of this `Rectangle`, represented by the returned `Dimension`.
`void` | `grow(int h, int v)` Resizes the `Rectangle` both horizontally and vertically.
`int` | `hashCode()` Returns the hashcode for this `Rectangle`.
`Rectangle` | `intersection(Rectangle r)` Computes the intersection of this `Rectangle` with the specified `Rectangle`.
`boolean` | `intersects(Rectangle r)` Determines whether or not this `Rectangle` and the specified `Rectangle` intersect.
`boolean` | `isEmpty()` Determines whether or not this `Rectangle` is empty.
`void` | `setBounds(int x, int y, int width, int height)` Sets the bounding `Rectangle` of this `Rectangle` to the specified `x`, `y`, `width`, and `height`.
`void` | `setBounds(Rectangle r)` Sets the bounding `Rectangle` of this `Rectangle` to match the specified `Rectangle`.
`void` | `setLocation(int x, int y)` Moves this `Rectangle` to the specified location.
`void` | `setLocation(Point p)` Moves this `Rectangle` to the specified location.
`void` | `setSize(Dimension d)` Sets the size of this `Rectangle` to match the specified `Dimension`.
`void` | `setSize(int width, int height)` Sets the size of this `Rectangle` to the specified width and height.
`String` | `toString()` Returns a `String` representing this `Rectangle` and its values.
`void` | `translate(int x, int y)` Translates this `Rectangle` the indicated distance, to the right along the x coordinate axis, and downward along the y coordinate axis.
`Rectangle` | `union(Rectangle r)` Computes the union of this `Rectangle` with the specified `Rectangle`.

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### x

    public int x

  The x coordinate of the `Rectangle`.

  See Also:
    `setLocation(int, int)`, `getLocation()`

### y

    public int y

  The y coordinate of the `Rectangle`.

  See Also:
    `setLocation(int, int)`, `getLocation()`

### width

    public int width

  The width of the `Rectangle`.

  Since:
    JDK1.0.
  See Also:
    `setSize(int, int)`, `getSize()`

### height

    public int height

  The height of the `Rectangle`.

  See Also:
    `setSize(int, int)`, `getSize()`

Constructor Detail

### Rectangle

    public Rectangle()

  Constructs a new `Rectangle` whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are both zero.

### Rectangle

    public Rectangle(Rectangle r)

  Constructs a new `Rectangle`, initialized to match the values of the specified `Rectangle`.

  Parameters:
    `r` - the `Rectangle` from which to copy initial values to a newly constructed `Rectangle`
  Since:
    JDK1.1

### Rectangle

    public Rectangle(int x,
                     int y,
                     int width,
                     int height)

  Constructs a new `Rectangle` whose top-left corner is specified as (`x`, `y`) and whose width and height are specified by the arguments of the same name.

  Parameters:
    `x` - the specified x coordinate
    `y` - the specified y coordinate
    `width` - the width of the `Rectangle`
    `height` - the height of the `Rectangle`

### Rectangle

    public Rectangle(int width,
                     int height)

  Constructs a new `Rectangle` whose top-left corner is at (0, 0) in the coordinate space, and whose width and height are specified by the arguments of the same name.

  Parameters:
    `width` - the width of the `Rectangle`
    `height` - the height of the `Rectangle`

### Rectangle

    public Rectangle(Point p,
                     Dimension d)

  Constructs a new `Rectangle` whose top-left corner is specified by the `Point` argument, and whose width and height are specified by the `Dimension` argument.

  Parameters:
    `p` - a `Point` that is the top-left corner of the `Rectangle`
    `d` - a `Dimension`, representing the width and height of the `Rectangle`

### Rectangle

    public Rectangle(Point p)

  Constructs a new `Rectangle` whose top-left corner is the specified `Point`, and whose width and height are both zero.

  Parameters:
    `p` - a `Point` that is the top left corner of the `Rectangle`

### Rectangle

    public Rectangle(Dimension d)

  Constructs a new `Rectangle` whose top left corner is (0, 0) and whose width and height are specified by the `Dimension` argument.

  Parameters:
    `d` - a `Dimension`, specifying width and height

Method Detail

### getBounds

    public Rectangle getBounds()

  Gets the bounding `Rectangle` of this `Rectangle`.

  This method is included for completeness, to parallel the `getBounds` method of `Component`.

  Specified by:
    `getBounds` in interface `Shape`
  Returns:
    a new `Rectangle`, equal to the bounding `Rectangle` for this `Rectangle`.
  Since:
    JDK1.1
  See Also:
    `Component.getBounds()`, `setBounds(Rectangle)`, `setBounds(int, int, int, int)`

### setBounds

    public void setBounds(Rectangle r)

  Sets the bounding `Rectangle` of this `Rectangle` to match the specified `Rectangle`.

  This method is included for completeness, to parallel the `setBounds` method of `Component`.

  Parameters:
    `r` - the specified `Rectangle`
  Since:
    JDK1.1
  See Also:
    `getBounds()`, `Component.setBounds(java.awt.Rectangle)`

### setBounds

    public void setBounds(int x,
                          int y,
                          int width,
                          int height)

  Sets the bounding `Rectangle` of this `Rectangle` to the specified `x`, `y`, `width`, and `height`.

  This method is included for completeness, to parallel the `setBounds` method of `Component`.

  Parameters:
    `x` - the new x coordinate for the top-left corner of this `Rectangle`
    `y` - the new y coordinate for the top-left corner of this `Rectangle`
    `width` - the new width for this `Rectangle`
    `height` - the new height for this `Rectangle`
  Since:
    JDK1.1
  See Also:
    `getBounds()`, `Component.setBounds(int, int, int, int)`

### getLocation

    public Point getLocation()

  Returns the location of this `Rectangle`.

  This method is included for completeness, to parallel the `getLocation` method of `Component`.

  Returns:
    the `Point` that is the top-left corner of this `Rectangle`.
  Since:
    JDK1.1
  See Also:
    `Component.getLocation()`, `setLocation(Point)`, `setLocation(int, int)`

### setLocation

    public void setLocation(Point p)

  Moves this `Rectangle` to the specified location.

  This method is included for completeness, to parallel the `setLocation` method of `Component`.

  Parameters:
    `p` - the `Point` specifying the new location for this `Rectangle`
  Since:
    JDK1.1
  See Also:
    `Component.setLocation(java.awt.Point)`, `getLocation()`

### setLocation

    public void setLocation(int x,
                            int y)

  Moves this `Rectangle` to the specified location.

  This method is included for completeness, to parallel the `setLocation` method of `Component`.

  Parameters:
    `x` - the x coordinate of the new location
    `y` - the y coordinate of the new location
  Since:
    JDK1.1
  See Also:
    `getLocation()`, `Component.setLocation(int, int)`

### translate

    public void translate(int x,
                          int y)

  Translates this `Rectangle` the indicated distance, to the right along the x coordinate axis, and downward along the y coordinate axis.

  Parameters:
    `x` - the distance to move this `Rectangle` along the x axis
    `y` - the distance to move this `Rectangle` along the y axis
  See Also:
    `setLocation(int, int)`, `setLocation(java.awt.Point)`

### getSize

    public Dimension getSize()

  Gets the size of this `Rectangle`, represented by the returned `Dimension`.

  This method is included for completeness, to parallel the `getSize` method of `Component`.

  Returns:
    a `Dimension`, representing the size of this `Rectangle`.
  Since:
    JDK1.1
  See Also:
    `Component.getSize()`, `setSize(Dimension)`, `setSize(int, int)`

### setSize

    public void setSize(Dimension d)

  Sets the size of this `Rectangle` to match the specified `Dimension`.

  This method is included for completeness, to parallel the `setSize` method of `Component`.

  Parameters:
    `d` - the new size for the `Dimension` object
  Since:
    JDK1.1
  See Also:
    `Component.setSize(java.awt.Dimension)`, `getSize()`

### setSize

    public void setSize(int width,
                        int height)

  Sets the size of this `Rectangle` to the specified width and height.

  This method is included for completeness, to parallel the `setSize` method of `Component`.

  Parameters:
    `width` - the new width for this `Rectangle`
    `height` - the new height for this `Rectangle`
  Since:
    JDK1.1
  See Also:
    `Component.setSize(int, int)`, `getSize()`

### contains

    public boolean contains(Point p)

  Checks whether or not this `Rectangle` contains the specified `Point`.

  Parameters:
    `p` - the `Point` to test
  Returns:
    `true` if the `Point` (x, y) is inside this `Rectangle`; `false` otherwise.
  Since:
    JDK1.1

### contains

    public boolean contains(int x,
                            int y)

  Checks whether or not this `Rectangle` contains the point at the specified location (x, y).

  Parameters:
    `x` - the specified x coordinate
    `y` - the specified y coordinate
  Returns:
    `true` if the point (x, y) is inside this `Rectangle`; `false` otherwise.
  Since:
    JDK1.1

### contains

    public boolean contains(Rectangle r)

  Checks whether or not this `Rectangle` entirely contains the specified `Rectangle`.

  Parameters:
    `r` - the specified `Rectangle`
  Returns:
    `true` if the `Rectangle` is contained entirely inside this `Rectangle`; `false` otherwise.
  Since:
    JDK1.1

### contains

    public boolean contains(int X,
                            int Y,
                            int W,
                            int H)

  Checks whether this `Rectangle` entirely contains the `Rectangle` at the specified location (X, Y) with the specified dimensions (W, H).

  Parameters:
    `X` - the specified x coordinate
    `Y` - the specified y coordinate
    `W` - the width of the `Rectangle`
    `H` - the height of the `Rectangle`
  Returns:
    `true` if the `Rectangle` specified by (X, Y, W, H) is entirely enclosed inside this `Rectangle`; `false` otherwise.
  Since:
    JDK1.1

### intersects

    public boolean intersects(Rectangle r)

  Determines whether or not this `Rectangle` and the specified `Rectangle` intersect. Two rectangles intersect if their intersection is nonempty.

  Parameters:
    `r` - the specified `Rectangle`
  Returns:
    `true` if the specified `Rectangle` and this `Rectangle` intersect; `false` otherwise.

### intersection

    public Rectangle intersection(Rectangle r)

  Computes the intersection of this `Rectangle` with the specified `Rectangle`. Returns a new `Rectangle` that represents the intersection of the two rectangles. If the two rectangles do not intersect, the result will be an empty rectangle.

  Parameters:
    `r` - the specified `Rectangle`
  Returns:
    the largest `Rectangle` contained in both the specified `Rectangle` and in this `Rectangle`; or if the rectangles do not intersect, an empty rectangle.

### union

    public Rectangle union(Rectangle r)

  Computes the union of this `Rectangle` with the specified `Rectangle`. Returns a new `Rectangle` that represents the union of the two rectangles

  Parameters:
    `r` - the specified `Rectangle`
  Returns:
    the smallest `Rectangle` containing both the specified `Rectangle` and this `Rectangle`.

### add

    public void add(int newx,
                    int newy)

  Adds a point, specified by the integer arguments `newx` and `newy`, to this `Rectangle`. The resulting `Rectangle` is the smallest `Rectangle` that contains both the original `Rectangle` and the specified point.

  After adding a point, a call to `contains` with the added point as an argument does not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a `Rectangle`. Therefore, if the added point falls on the right or bottom edge of the enlarged `Rectangle`, `contains` returns `false` for that point.

  Parameters:
    `newx` - the x coordinate of the new point
    `newy` - the y coordinate of the new point

### add

    public void add(Point pt)

  Adds the specified `Point` to this `Rectangle`. The resulting `Rectangle` is the smallest `Rectangle` that contains both the original `Rectangle` and the specified `Point`.

  After adding a `Point`, a call to `contains` with the added `Point` as an argument does not necessarily return `true`. The `contains` method does not return `true` for points on the right or bottom edges of a `Rectangle`. Therefore if the added `Point` falls on the right or bottom edge of the enlarged `Rectangle`, `contains` returns `false` for that `Point`.

  Parameters:
    `pt` - the new `Point` to add to this `Rectangle`

### add

    public void add(Rectangle r)

  Adds a `Rectangle` to this `Rectangle`. The resulting `Rectangle` is the union of the two rectangles.

  Parameters:
    `r` - the specified `Rectangle`

### grow

    public void grow(int h,
                     int v)

  Resizes the `Rectangle` both horizontally and vertically.

  This method modifies the `Rectangle` so that it is `h` units larger on both the left and right side, and `v` units larger at both the top and bottom.

  The new `Rectangle` has (`x - h`, `y - v`) as its top-left corner, a width of `width` `+` `2h`, and a height of `height` `+` `2v`.

  If negative values are supplied for `h` and `v`, the size of the `Rectangle` decreases accordingly. The `grow` method does not check whether the resulting values of `width` and `height` are non-negative.

  Parameters:
    `h` - the horizontal expansion
    `v` - the vertical expansion

### isEmpty

    public boolean isEmpty()

  Determines whether or not this `Rectangle` is empty. A `Rectangle` is empty if its width or its height is less than or equal to zero.

  Returns:
    `true` if this `Rectangle` is empty; `false` otherwise.

### equals

    public boolean equals(Object obj)

  Checks whether two rectangles are equal.

  The result is `true` if and only if the argument is not `null` and is a `Rectangle` object that has the same top-left corner, width, and height as this `Rectangle`.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the `Object` to compare with this `Rectangle`
  Returns:
    `true` if the objects are equal; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### toString

    public String toString()

  Returns a `String` representing this `Rectangle` and its values.

  Overrides:
    `toString` in class `Object`
  Returns:
    a `String` representing this `Rectangle` object's coordinate and size values.

### clone

    public Object clone()

  Creates a new object of the same class and with the same contents as this object.

  Returns:
    a clone of this instance.
  Throws:
    `OutOfMemoryError` - if there is not enough memory.
  Since:
    1.2
  See Also:
    `Cloneable`

### hashCode

    public int hashCode()

  Returns the hashcode for this `Rectangle`.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code for this `Rectangle`.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD